package com.pms.ocp.common.utils;

import com.pms.ocp.model.entity.ApiParam;

import java.util.ArrayList;
import java.util.List;

/**
 * @author guofanfan
 * 树形
 */
public class ParamTree {
    private List<ApiParam> apiParamList = new ArrayList<>();

    public ParamTree(List<ApiParam> apiParamList) {
        this.apiParamList = apiParamList;
    }

    //建立属性结构
    public List<ApiParam> buildTree() {
        List<ApiParam> treeMenus = new ArrayList<>();
        for (ApiParam apiParam : getRootNode()) {
            apiParam = buildChildren(apiParam);
            treeMenus.add(apiParam);
        }
        return treeMenus;
    }
    //递归  子树
    private  ApiParam buildChildren(ApiParam apiParam){
        List<ApiParam> list = new ArrayList<>();
        for (ApiParam param : apiParamList) {
            if (param.getPid().equals(apiParam.getApiCode())){
                list.add(buildChildren(param));
            }
        }
        apiParam.setInChildrenList(list);
        return apiParam;
    }

//父节点
    private List<ApiParam> getRootNode() {
        List<ApiParam> objects = new ArrayList<>();
        for (ApiParam apiParam : apiParamList) {
            if (BeagleStringUtils.isEmpty(apiParam.getPid())) {
                objects.add(apiParam);
            }
        }
        return objects;
    }
}

