package com.pms.ocp.controller;

import com.pms.ocp.common.aspectj.WebLog;
import com.pms.ocp.model.dto.AcceptDTO;
import com.pms.ocp.model.dto.CommitDTO;
import com.pms.ocp.model.dto.RatioDTO;
import com.pms.ocp.model.vo.ResponseVO;
import com.pms.ocp.service.AcceptInfoService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * 服务验收控制器
 *
 * @author Administrator
 */
@RestController
@RequestMapping("acceptInfo")
@Api(tags = "重合度相关")
public class AcceptInfoController {


    @Autowired
    private AcceptInfoService acceptInfoService;

    @ApiOperation("服务验收")
    @PostMapping("accept")
    @WebLog(description = "服务验收")
    public ResponseVO acceptInfo(@RequestBody AcceptDTO acceptDTO) {
        ResponseVO vo = acceptInfoService.acceptInfo(acceptDTO);
        return vo;
    }

    @ApiOperation("重合度")
    @PostMapping("apiModelRepeat")
    @WebLog(description = "重合度")
    public ResponseVO apiModelRepeat(@RequestBody RatioDTO ratioDTO) {
        ResponseVO vo = acceptInfoService.apiModelRepeat(ratioDTO);
        return vo;
    }


    @ApiOperation("提交")
    @PostMapping("apiModelRepeatCommit")
    @WebLog(description = "提交")
    public ResponseVO apiModelRepeatCommit(@RequestBody CommitDTO commitDTO) {
        ResponseVO vo = acceptInfoService.apiModelRepeatCommit(commitDTO);
        return vo;
    }

    @ApiOperation("审核人信息")
    @PostMapping("acceptPeopleInfo")
    @WebLog(description = "审核人信息")
    public ResponseVO acceptPeopleInfo(@RequestBody AcceptDTO acceptDTO) {
        ResponseVO vo = acceptInfoService.acceptPeopleInfo(acceptDTO);
        return vo;
    }

}
