package com.pms.ocp.controller;

import com.github.pagehelper.PageInfo;
import com.pms.ocp.model.entity.PmsApiModelRel;
import com.pms.ocp.model.entity.PmsApiTenantRel;
import com.pms.ocp.model.vo.ApiRequirentVo;
import com.pms.ocp.model.vo.OcpApiGroupVo;
import com.pms.ocp.model.vo.OcpApiRequirementVo;
import com.pms.ocp.model.vo.ResponseVO;
import com.pms.ocp.service.OcpApiReqService;
import com.pms.ocp.service.PmsApiModelRelService;
import com.pms.ocp.service.PmsApiTenantRelService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@Slf4j
@RequestMapping("/apireq")
@RestController
@Api(tags = "服务管控接口")
public class OcpApiReqController {

    @Autowired
    private OcpApiReqService ocpApiReqService;

    @ApiOperation("服务管控导航树-统推/自建")
    @GetMapping("OacrTree")
    public ResponseVO<List<OcpApiRequirementVo>> OacrTree(OcpApiRequirementVo ocpApiRequirementVo) {
        return ocpApiReqService.OacrTree(ocpApiRequirementVo);
    }

    @ApiOperation("服务管控导航树-查询中心")
    @GetMapping("OacrTreeCenter")
    public ResponseVO<List<OcpApiRequirementVo>> OacrTreeCenter(OcpApiRequirementVo ocpApiRequirementVo) {
        return ocpApiReqService.OacrTreeCenter(ocpApiRequirementVo);
    }


    @ApiOperation("服务管控导航树-查询所属服务")
    @GetMapping("OacrTreeApi")
    public ResponseVO<List<OcpApiRequirementVo>> OacrTreeApi(OcpApiRequirementVo ocpApiRequirementVo) {
        return ocpApiReqService.OacrTreeApi(ocpApiRequirementVo);
    }


    @ApiOperation("服务管控-列表")
    @GetMapping("OarcList")
    public ResponseVO<PageInfo<OcpApiRequirementVo>> OarcList(OcpApiRequirementVo ocpApiRequirementVo) {
        return ocpApiReqService.OcpApiReq(ocpApiRequirementVo);
    }

    @ApiOperation("服务管控需求变更-审核")
    @GetMapping("OarcCheck")
    public ResponseVO<List<OcpApiRequirementVo>> OarcCheck(OcpApiRequirementVo ocpApiRequirementVo) {
        return ocpApiReqService.OarcCheck(ocpApiRequirementVo);
    }

    @ApiOperation("服务管控-列表详情")
    @GetMapping("SelectOarcList")
    public ResponseVO SelectOarcList(String apiCode) {
        ApiRequirentVo apiRequirentVo = ocpApiReqService.selectOarcList(apiCode);
        return ResponseVO.ok(apiRequirentVo);
    }

    @ApiOperation("服务管控-验收列表")
    @GetMapping("OaratList")
    public ResponseVO<PageInfo<OcpApiRequirementVo>> OaratList(OcpApiRequirementVo ocpApiRequirementVo) {
        return ocpApiReqService.OcpApiReqAcc(ocpApiRequirementVo);
    }

    @ApiOperation("服务管控-验收列表详情")
    @GetMapping("SelectOaratList")
    public ResponseVO<List<OcpApiRequirementVo>> SelectOaratList(OcpApiRequirementVo ocpApiRequirementVo) {
        return ocpApiReqService.selectOcpApiReqAcc(ocpApiRequirementVo);
    }

//    @ApiOperation("服务与模型关联关系")
//    @PostMapping("/getoamrlist")
//    public ResponseVO<List<PmsApiModelRel>> getOamrList(@RequestBody PmsApiModelRel pmsApiModelRel) {
//        return pmsApiModelRelService.getOamrList(pmsApiModelRel);
//    }

    @ApiOperation("服务与应用关联关系")
    @PostMapping("/getoatrlist")
    public ResponseVO<List<OcpApiRequirementVo>> getOatrList(@RequestBody OcpApiRequirementVo ocpApiRequirementVo) {
        return ocpApiReqService.getOcpTenantApiList(ocpApiRequirementVo);
    }

    @ApiOperation("服务需求审核进度")
    @GetMapping("OcpApiCheck")
    public ResponseVO<List<OcpApiRequirementVo>> OcpApiCheck(OcpApiRequirementVo ocpApiRequirementVo) {
        return ocpApiReqService.OcpApiCheck(ocpApiRequirementVo);
    }






}
