package com.pms.ocp.model.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.time.LocalDateTime;

/**
 * @Auther: wangjian
 * @Date: 2022/2/22 16:52
 * @Description:模型事记记录对象
 */

@Data
@TableName("ocp_model_audit")
public class ModelAudit {

    /**
     * 事记表主键
     */
    @TableId(value = "obj_id", type = IdType.ASSIGN_ID)
    private String objId;

    /**
     * 模型代码
     */
    private String modelCode;

    /**
     * 属性代码
     */
    private String propCode;

    /**
     * 异动类型 0:新增,1:迭代
     */
    private Integer operStatus;

    /**
     * 操作对象0:表，1:属性
     */
    private Integer operTarget;

    /**
     * 事记类型 0:人工操作,1:流程管控,3:总部下发
     */
    private int auditType;

    /**
     * 模型异动详情
     */
    private String auditMessageJson;

    /**
     * 异动申请人id
     */
    private String applyUserId;

    /**
     * 异动申请人姓名
     */
    private String applyUserName;

    /**
     * 提交人id
     */
    private String auditUserId;

    /**
     * 提交人姓名
     */
    private String auditUserName;

    /**
     * 异动时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private LocalDateTime applyTime;

    /**
     * 事记新增时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private LocalDateTime auditCtime;

    /**
     * 事记修改时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private LocalDateTime auditMtime;

    /**
     * 版本
     */
    private String applyVersion;

    /**
     * 异动公司编号
     */
    private String auditCompanyCode;

    /**
     * 上一版本
     */
    private String preModelVersion;

}

//
//    COMMENT ON COLUMN public.ocp_model_audit.obj_id IS '主键是';
//        COMMENT ON COLUMN public.ocp_model_audit.model_code IS '模型代码是';
//        COMMENT ON COLUMN public.ocp_model_audit.prop_code IS '属性代码';
//        COMMENT ON COLUMN public.ocp_model_audit.oper_status IS '异动类型0:新增,1:迭代';
//        COMMENT ON COLUMN public.ocp_model_audit.oper_target IS '操作对象0:表，1:属性';
//        COMMENT ON COLUMN public.ocp_model_audit.audit_type IS '事记类型0:人工操作,1:流程管控,3:总部下发';
//        COMMENT ON COLUMN public.ocp_model_audit.audit_message_json IS '模型异动详情';
//        COMMENT ON COLUMN public.ocp_model_audit.apply_user_id IS '异动申请人id';
//        COMMENT ON COLUMN public.ocp_model_audit.apply_user_name IS '异动申请人';
//        COMMENT ON COLUMN public.ocp_model_audit.apply_time IS '异动时间';
//        COMMENT ON COLUMN public.ocp_model_audit.audit_ctime IS '申请时间';
//        COMMENT ON COLUMN public.ocp_model_audit.audit_mtime IS '修改时间';
//        COMMENT ON COLUMN public.ocp_model_audit.apply_version IS '版本';
//        COMMENT ON COLUMN public.ocp_model_audit.audit_company_code IS '异动公司code';
//        COMMENT ON COLUMN public.ocp_model_audit.audit_user_id IS '提交人id';
//        COMMENT ON COLUMN public.ocp_model_audit.audit_user_name IS '提交人姓名';
