package com.pms.ocp.model.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.time.LocalDateTime;
import java.util.UUID;

/**
 * @Auther: wangjian
 * @Date: 2022/3/29 17:27
 * @Description:模型需求表对象
 */

@Data
@TableName("ocp_model_requirement")
public class ModelRequirement {

    /**
     * 主键
     */
    @TableId(value = "obj_id", type = IdType.ASSIGN_ID)
    private String objId;

    /**
     * 需求编码
     */
    private String requirementCode;

    /**
     * 需求类型 0:新增，1:迭代，2下线
     */
    private Integer requirementType;

    /**
     * 需求简述
     */
    private String requirementDesc;

    /**
     * 需求提报公司
     */
    private String companyCode;

    /**
     * 提交人id
     */
    private String userId;

    /**
     * 提交人姓名
     */
    private String userName;

    /**
     * 创建时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private LocalDateTime ctime;

    /**
     * 修改时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private LocalDateTime mtime;

    /**
     * 需求审核状态0:未通过1:通过
     */
    private Integer requirementStatus;

//    /**
//     *
//     */
//    private String approvalCompanyCode;
}

