package com.pms.ocp.model.entity;


import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;

import java.sql.Timestamp;

@Data
@Accessors(chain = true)
@TableName("ocp_api_requirement")
@ApiModel("服务需求表")
public class OcpApiRequirement  {

    @TableId(type = IdType.ASSIGN_ID)
    @ApiModelProperty("主键ID")
    private String objId;

    @ApiModelProperty("需求编码")
    private String requirementCode;

    @ApiModelProperty("需求类型0:新增，1:迭代，2下线")
    private Long requirementType;

    @ApiModelProperty("需求简述")
    private String requirementComments;

    @ApiModelProperty("服务编码")
    private String apiCode;


    @ApiModelProperty("服务名称")
    private String apiName;

    @ApiModelProperty("服务分类代码")
    private String apiGroupCode;

    @ApiModelProperty("服务地址")
    private String apiUrl;

    @ApiModelProperty("服务版本号")
    private String apiVersion;

    @ApiModelProperty("需求填报人id")
    private String requirementUserId;

    @ApiModelProperty("需求填报人姓名")
    private String requirementUserName;

    @ApiModelProperty("需求创建时间")
    private Timestamp requirementCtime;

    @ApiModelProperty("需求修改时间")
    private Timestamp requirementMtime;

    @ApiModelProperty("是否删除0：否 1：是")
    private Long isDelete;

    @ApiModelProperty("所属区域1:生成控制大区 2：信息关联大区3：互联网大区")
    private Long apiZone;

    @ApiModelProperty("所属层级1: 应用层 2：平台层、3：网络层 4：感知层")
    private Long apiLayer;

    @ApiModelProperty("建设单位")
    private String apiUnit;

    @ApiModelProperty("服务所属公司")
    private String ownerCompanyCode;

    @ApiModelProperty("推广类型0:统建 1:自建")
    private Long apiPromotion;

    @ApiModelProperty("服务请求体    ")
    private String apiReq;

    @ApiModelProperty("服务返回体")
    private String apiResp;

    @ApiModelProperty("需求填报人部门")
    private String requirementUserDepg;

    @TableField(exist = false)
    @ApiModelProperty("初审")
    private Integer approvalStats;
    @TableField(exist = false)
    @ApiModelProperty("终审")
    private Integer lastApprovalStats;

    public Integer getApprovalStats() {
        return approvalStats;
    }

    public void setApprovalStats(Integer approvalStats) {
        this.approvalStats = approvalStats;
    }

    public Integer getLastApprovalStats() {
        return lastApprovalStats;
    }

    public void setLastApprovalStats(Integer lastApprovalStats) {
        this.lastApprovalStats = lastApprovalStats;
    }

    public Long getRequirementType() {
        return requirementType;
    }

    public void setRequirementType(Long requirementType) {
        this.requirementType = requirementType;
    }

    public Long getIsDelete() {
        return isDelete;
    }

    public void setIsDelete(Long isDelete) {
        this.isDelete = isDelete;
    }

    public Long getApiZone() {
        return apiZone;
    }

    public void setApiZone(Long apiZone) {
        this.apiZone = apiZone;
    }

    public Long getApiLayer() {
        return apiLayer;
    }

    public void setApiLayer(Long apiLayer) {
        this.apiLayer = apiLayer;
    }

    public Long getApiPromotion() {
        return apiPromotion;
    }

    public void setApiPromotion(Long apiPromotion) {
        this.apiPromotion = apiPromotion;
    }

    public String getObjId() {
        return objId;
    }

    public void setObjId(String objId) {
        this.objId = objId;
    }

    public String getRequirementCode() {
        return requirementCode;
    }

    public void setRequirementCode(String requirementCode) {
        this.requirementCode = requirementCode;
    }



    public String getRequirementComments() {
        return requirementComments;
    }

    public void setRequirementComments(String requirementComments) {
        this.requirementComments = requirementComments;
    }

    public String getApiCode() {
        return apiCode;
    }

    public void setApiCode(String apiCode) {
        this.apiCode = apiCode;
    }

    public String getApiName() {
        return apiName;
    }

    public void setApiName(String apiName) {
        this.apiName = apiName;
    }

    public String getApiGroupCode() {
        return apiGroupCode;
    }

    public void setApiGroupCode(String apiGroupCode) {
        this.apiGroupCode = apiGroupCode;
    }

    public String getApiUrl() {
        return apiUrl;
    }

    public void setApiUrl(String apiUrl) {
        this.apiUrl = apiUrl;
    }

    public String getApiVersion() {
        return apiVersion;
    }

    public void setApiVersion(String apiVersion) {
        this.apiVersion = apiVersion;
    }

    public String getRequirementUserId() {
        return requirementUserId;
    }

    public void setRequirementUserId(String requirementUserId) {
        this.requirementUserId = requirementUserId;
    }

    public String getRequirementUserName() {
        return requirementUserName;
    }

    public void setRequirementUserName(String requirementUserName) {
        this.requirementUserName = requirementUserName;
    }

    public Timestamp getRequirementCtime() {
        return requirementCtime;
    }

    public void setRequirementCtime(Timestamp requirementCtime) {
        this.requirementCtime = requirementCtime;
    }

    public Timestamp getRequirementMtime() {
        return requirementMtime;
    }

    public void setRequirementMtime(Timestamp requirementMtime) {
        this.requirementMtime = requirementMtime;
    }

    public String getApiUnit() {
        return apiUnit;
    }

    public void setApiUnit(String apiUnit) {
        this.apiUnit = apiUnit;
    }

    public String getOwnerCompanyCode() {
        return ownerCompanyCode;
    }

    public void setOwnerCompanyCode(String ownerCompanyCode) {
        this.ownerCompanyCode = ownerCompanyCode;
    }


    public String getApiReq() {
        return apiReq;
    }

    public void setApiReq(String apiReq) {
        this.apiReq = apiReq;
    }

    public String getApiResp() {
        return apiResp;
    }

    public void setApiResp(String apiResp) {
        this.apiResp = apiResp;
    }

    public String getRequirementUserDepg() {
        return requirementUserDepg;
    }

    public void setRequirementUserDepg(String requirementUserDepg) {
        this.requirementUserDepg = requirementUserDepg;
    }
}
