package com.pms.ocp.model.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;

import java.sql.Timestamp;

@Data
@Accessors(chain = true)
@TableName("ocp_api_requirement_accept")
@ApiModel("服务需求验收表")
public class OcpApiRequirementAccept {

    @TableId(type = IdType.ASSIGN_ID)
    @ApiModelProperty("主键ID")
    private String objId;


    @ApiModelProperty("需求编码")
    private String requirementCode;

    @ApiModelProperty("服务编码")
    private String apiCode;

    @ApiModelProperty("验收状态0:未验收 1：验收通过 2：验收拒绝")
    private Long acceptStats;

    @ApiModelProperty("验收单位")
    private String acceptCompanyCode;

    @ApiModelProperty("验收部门")
    private String acceptDepartment;

    @ApiModelProperty("验收人")
    private String acceptUserId;

    @ApiModelProperty("验收人姓名")
    private String acceptUserName;

    @ApiModelProperty("验收时间")
    private Timestamp acceptCtime;

    @ApiModelProperty("修改时间")
    private Timestamp acceptMtime;

    @ApiModelProperty("是否删除0：否 1：是")
    private Long isDelete;


    public String getObjId() {
        return objId;
    }

    public void setObjId(String objId) {
        this.objId = objId;
    }

    public String getRequirementCode() {
        return requirementCode;
    }

    public void setRequirementCode(String requirementCode) {
        this.requirementCode = requirementCode;
    }

    public String getApiCode() {
        return apiCode;
    }

    public void setApiCode(String apiCode) {
        this.apiCode = apiCode;
    }

    public Long getAcceptStats() {
        return acceptStats;
    }

    public void setAcceptStats(Long acceptStats) {
        this.acceptStats = acceptStats;
    }

    public String getAcceptCompanyCode() {
        return acceptCompanyCode;
    }

    public void setAcceptCompanyCode(String acceptCompanyCode) {
        this.acceptCompanyCode = acceptCompanyCode;
    }

    public String getAcceptDepartment() {
        return acceptDepartment;
    }

    public void setAcceptDepartment(String acceptDepartment) {
        this.acceptDepartment = acceptDepartment;
    }

    public String getAcceptUserId() {
        return acceptUserId;
    }

    public void setAcceptUserId(String acceptUserId) {
        this.acceptUserId = acceptUserId;
    }

    public String getAcceptUserName() {
        return acceptUserName;
    }

    public void setAcceptUserName(String acceptUserName) {
        this.acceptUserName = acceptUserName;
    }

    public void setAcceptCtime(Timestamp acceptCtime) {
        this.acceptCtime = acceptCtime;
    }

    public void setAcceptMtime(Timestamp acceptMtime) {
        this.acceptMtime = acceptMtime;
    }

    public Long getIsDelete() {
        return isDelete;
    }

    public void setIsDelete(Long isDelete) {
        this.isDelete = isDelete;
    }
}
