package com.pms.ocp.model.entity;


import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;

import java.sql.Timestamp;

@Data
@Accessors(chain = true)
@TableName("ocp_api_requirement_approval")
@ApiModel("服务需求审批表")
public class OcpApiRequirementApproval {


    @TableId(type = IdType.ASSIGN_ID)
    @ApiModelProperty("主键ID")
    private String objId;

    @ApiModelProperty("需求编码")
    private String requirementCode;

    @ApiModelProperty("审批状态0:未审核 1：审核通过 2：审批拒绝")
    private Long approvalStats;

    @ApiModelProperty("最终审批状态0:未审核 1：审核通过 2：审批拒绝")
    private Long lastApprovalStats;

    @ApiModelProperty("审核人单位")
    private String approvalCompanyCode;

    @ApiModelProperty("审核人部门")
    private String approvalDepartment;

    @ApiModelProperty("审核人id")
    private String approvalUserId;

    @ApiModelProperty("审核人姓名")
    private String approvalUserName;

    @ApiModelProperty("审核时间")
    private Timestamp approvalCtime;

    @ApiModelProperty("修改时间")
    private Timestamp approvalMtime;

    @ApiModelProperty("是否删除0：否 1：是")
    private Long isDelete;

    @ApiModelProperty("审核意见")
    private String approvalComment;

    @ApiModelProperty("服务编码")
    private String apiCode;
    @ApiModelProperty("审核层次：0初审1终审")
    private Long  approvalAudit;
    @ApiModelProperty("判断：1: 管理员 2：领导")
    @TableField(exist = false)
    private String lev;

    public String getApiCode() {
        return apiCode;
    }

    public void setApiCode(String apiCode) {
        this.apiCode = apiCode;
    }

    public String getLev() {
        return lev;
    }

    public void setLev(String lev) {
        this.lev = lev;
    }

    public String getObjId() {
        return objId;
    }

    public void setObjId(String objId) {
        this.objId = objId;
    }

    public String getRequirementCode() {
        return requirementCode;
    }

    public void setRequirementCode(String requirementCode) {
        this.requirementCode = requirementCode;
    }

    public Long getApprovalStats() {
        return approvalStats;
    }

    public void setApprovalStats(Long approvalStats) {
        this.approvalStats = approvalStats;
    }

    public Long getLastApprovalStats() {
        return lastApprovalStats;
    }

    public void setLastApprovalStats(Long lastApprovalStats) {
        this.lastApprovalStats = lastApprovalStats;
    }

    public String getApprovalCompanyCode() {
        return approvalCompanyCode;
    }

    public void setApprovalCompanyCode(String approvalCompanyCode) {
        this.approvalCompanyCode = approvalCompanyCode;
    }

    public String getApprovalDepartment() {
        return approvalDepartment;
    }

    public void setApprovalDepartment(String approvalDepartment) {
        this.approvalDepartment = approvalDepartment;
    }

    public String getApprovalUserId() {
        return approvalUserId;
    }

    public void setApprovalUserId(String approvalUserId) {
        this.approvalUserId = approvalUserId;
    }

    public String getApprovalUserName() {
        return approvalUserName;
    }

    public void setApprovalUserName(String approvalUserName) {
        this.approvalUserName = approvalUserName;
    }

    public Timestamp getApprovalCtime() {
        return approvalCtime;
    }

    public void setApprovalCtime(Timestamp approvalCtime) {
        this.approvalCtime = approvalCtime;
    }

    public Timestamp getApprovalMtime() {
        return approvalMtime;
    }

    public void setApprovalMtime(Timestamp approvalMtime) {
        this.approvalMtime = approvalMtime;
    }

    public Long getIsDelete() {
        return isDelete;
    }

    public void setIsDelete(Long isDelete) {
        this.isDelete = isDelete;
    }

    public String getApprovalComment() {
        return approvalComment;
    }

    public void setApprovalComment(String approvalComment) {
        this.approvalComment = approvalComment;
    }
}
