package com.pms.ocp.model.entity;


import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;

@Data
@Accessors(chain = true)
@TableName("ocp_api_requirement_extent")
@ApiModel("服务需求扩展表")
public class OcpApiRequirementExtent {


    @TableId(type = IdType.ASSIGN_ID)
    @ApiModelProperty("主键ID")
    private String objId;

    @ApiModelProperty("需求编码")
    private String requirementCode;

    @ApiModelProperty("服务编码")
    private String apiCode;

    @ApiModelProperty("K8s中的service名称")
    private String serviceName;

    @ApiModelProperty("所属集群")
    private String clusterName;

    @ApiModelProperty("部署在K8s中的deploymentname")
    private String deployment;

    @ApiModelProperty("添加时间")
    private String apiCtime;

    @ApiModelProperty("修改时间")
    private String apiMtime;

    @ApiModelProperty("部署包名称")
    private String apiDepPacketname;

    @ApiModelProperty("是否已删除")
    private Long isDelete;

    public String getObjId() {
        return objId;
    }

    public void setObjId(String objId) {
        this.objId = objId;
    }

    public String getRequirementCode() {
        return requirementCode;
    }

    public void setRequirementCode(String requirementCode) {
        this.requirementCode = requirementCode;
    }

    public String getApiCode() {
        return apiCode;
    }

    public void setApiCode(String apiCode) {
        this.apiCode = apiCode;
    }

    public String getServiceName() {
        return serviceName;
    }

    public void setServiceName(String serviceName) {
        this.serviceName = serviceName;
    }

    public String getClusterName() {
        return clusterName;
    }

    public void setClusterName(String clusterName) {
        this.clusterName = clusterName;
    }

    public String getDeployment() {
        return deployment;
    }

    public void setDeployment(String deployment) {
        this.deployment = deployment;
    }


    public String getApiDepPacketname() {
        return apiDepPacketname;
    }

    public void setApiDepPacketname(String apiDepPacketname) {
        this.apiDepPacketname = apiDepPacketname;
    }

    public String getApiCtime() {
        return apiCtime;
    }


    public void setApiCtime(String apiCtime) {
        this.apiCtime = apiCtime;
    }

    public String getApiMtime() {
        return apiMtime;
    }

    public void setApiMtime(String apiMtime) {
        this.apiMtime = apiMtime;
    }

    public Long getIsDelete() {
        return isDelete;
    }

    public void setIsDelete(Long isDelete) {
        this.isDelete = isDelete;
    }
}
