package com.pms.ocp.service.impl;


import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.pms.ocp.mapper.*;
import com.pms.ocp.model.entity.*;
import com.pms.ocp.model.vo.ApiRequirentVo;
import com.pms.ocp.model.vo.OcpApiBaseVo;
import com.pms.ocp.model.vo.OcpApiRequirementVo;
import com.pms.ocp.model.vo.ResponseVO;
import com.pms.ocp.service.OcpApiReqService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;
import java.util.stream.Collectors;

@Service
public class OcpApiReqServiceImpl extends ServiceImpl<OcpApiReqMapper, OcpApiRequirementVo> implements OcpApiReqService {

    @Autowired
    private OcpApiReqMapper ocpApiReqMapper;

    @Autowired
    private OcpApiBaseMapper ocpApiBaseMapper;

    @Autowired
    private OcpApiGroupMapper ocpApiGroupMapper;
    @Autowired
    private OcpApiModelRelMapper ocpApiModelRelMapper;

    @Autowired
    private OcpBaseMapper ocpBaseMapper;

    @Autowired
    private OcpTenantBaseMapper ocpTenantBaseMapper;

    @Autowired
    private OcpApiPMapper ocpApiPMapper;


    @Autowired
    private OcptenantRelMapper ocptenantRelMapper;

    @Autowired
    private OcpApiRequirementMapper ocpApiRequirementMapper;

    @Autowired
    private OcpApiRequirementApprovalMapper ocpApiRequirementApprovalMapper;

    List<String> apiGroupCode = new ArrayList<>();

    @Override
    public ResponseVO<PageInfo<OcpApiRequirementVo>> OcpApiReq(OcpApiRequirementVo ocpApiRequirementVo) {
        if (ocpApiRequirementVo.getCurrentPage() == null || ocpApiRequirementVo.getPageSize() == null) {
            return ResponseVO.error("分页参数不能为空");
        }

        apiGroupCode.add(ocpApiRequirementVo.getApiGroupCode());
        setGroupIdValue(ocpApiRequirementVo.getApiGroupCode(), ocpApiRequirementVo.getApiPromotion());
        PageHelper.startPage(ocpApiRequirementVo.getCurrentPage(), ocpApiRequirementVo.getPageSize());
        ocpApiRequirementVo.setApiGroupCodeList(apiGroupCode);
        List<OcpApiRequirementVo> ocpApiRequirements = ocpApiReqMapper.OcpApiReq(ocpApiRequirementVo);
        for (OcpApiRequirementVo cod : ocpApiRequirements) {
            OcpApiRequirementApproval approval = ocpApiRequirementApprovalMapper.selectByReqCodes(cod.getRequirementCode());
            if(approval!=null) {
                cod.setLastApprovalStats(Math.toIntExact(approval.getLastApprovalStats()));
                cod.setApprovalStats(Math.toIntExact(approval.getApprovalStats()));
            }else {
                cod.setLastApprovalStats(0);
                cod.setApprovalStats(0);
            }
            }
        apiGroupCode.clear();
        PageInfo<OcpApiRequirementVo> pageInfo = new PageInfo<>(ocpApiRequirements);
        return ResponseVO.ok(pageInfo);
    }

    /**
     * 分组权限分组使用in查询
     *
     * @param
     * @param
     */
    private void setGroupIdValue(String code, Integer apiGroupPromotionType) {
        List<String> codes = getIdsByPIdPub(null,code, apiGroupPromotionType);
        if (codes.size() > 0) {
            for (String cod : codes) {
                setGroupIdValue(cod, apiGroupPromotionType);
                apiGroupCode.add(cod);
            }
            ;
        }
    }

    public List<String> getIdsByPIdPub(String apiGroupCompanyCode, String code, Integer apiGroupPromotionType) {
        List<OcpApiGroup> ocpApiGroups = ocpApiGroupMapper.apiBaseTreeOther(apiGroupCompanyCode, code, apiGroupPromotionType);
        return ocpApiGroups.stream().map(OcpApiGroup::getApiGroupCode).collect(Collectors.toList());
    }

    @Override
    public ResponseVO<List<OcpApiRequirementVo>> OacrTree(OcpApiRequirementVo ocpApiRequirementVo) {
        List<OcpApiRequirementVo> ocpTree = ocpApiReqMapper.getOcpTree(ocpApiRequirementVo);
        return ResponseVO.ok(ocpTree);
    }

    @Override
    public ResponseVO<List<OcpApiRequirementVo>> OacrTreeCenter(OcpApiRequirementVo ocpApiRequirementVo) {
        List<OcpApiRequirementVo> ocpTree = ocpApiReqMapper.OacrTreeCenter(ocpApiRequirementVo);
        return ResponseVO.ok(ocpTree);
    }


    @Override
    public ApiRequirentVo selectOarcList(String apiCode) {
        //出参
        List<OcpApiParam> list = new ArrayList<>();
        //入参
        List<OcpApiParam> lists = new ArrayList<>();
        //应用描述
        List<String> listTenant = new ArrayList<>();
        //影响应用
        List<String> list1Tenat = new ArrayList<>();
        //影响模型
        List<Model> listModel = new ArrayList<>();
        //影响模型
        List<String> list1Model = new ArrayList<>();

        //返回值对象
        ApiRequirentVo apiRequirentVo = new ApiRequirentVo();

        //查询服务审批详情
        OcpApiBase ocpApiBase = ocpBaseMapper.selectCode(apiCode);
        OcpApiRequirement ocpApiRequirement = ocpApiRequirementMapper.selectByCodes(ocpApiBase.getApiCode());

        OcpApiRequirementApproval approval = ocpApiRequirementApprovalMapper.selectByReqCodes(ocpApiRequirement.getRequirementCode());
        if(approval!=null) {
           ocpApiRequirement.setLastApprovalStats(Math.toIntExact(approval.getLastApprovalStats()));
           ocpApiRequirement.setApprovalStats(Math.toIntExact(approval.getApprovalStats()));
        }else {
            ocpApiRequirement.setLastApprovalStats(0);
            ocpApiRequirement.setApprovalStats(0);
        }

        //据apicode查询模型关系表
        List<OcpApiModelRel> model = ocpApiModelRelMapper.selectApiGroupds(ocpApiRequirement.getApiCode());
        //根据modelCode查询模型名称
        for (OcpApiModelRel ocpApiModelRel : model) {
            if (StringUtils.isNotEmpty(ocpApiModelRel.getModelCode())) {
                List<Model> ocpModelBase = ocpBaseMapper.selectModelBase(ocpApiModelRel.getModelCode());
                if (ocpModelBase.size() >= 1) {
                    for (Model model1 : ocpModelBase) {
                        listModel.add(model1);
                        list1Model.add(model1.getApiUnit());
                    }
                    apiRequirentVo.setApiModelNames(listModel);
                    apiRequirentVo.setModelDescription(list1Model);
                }
            }
        }


        //根据apicode查询应用关系表
        List<OcpApiTenantRel> ocpApiTenantRelList = ocptenantRelMapper.selectTenant(ocpApiRequirement.getApiCode());
        for (OcpApiTenantRel ocpApiTenantRel : ocpApiTenantRelList) {
            //根据tenant_code查询每个应用名称
            OcpTenantBase ocpTenantBase = ocpTenantBaseMapper.selectTenants(ocpApiTenantRel.getTenantCode());
            listTenant.add(ocpTenantBase.getTenantDescription());
            list1Tenat.add(ocpTenantBase.getTenantName());
        }
        apiRequirentVo.setTenantDescription(listTenant);
        apiRequirentVo.setApiTenantGroupNames(list1Tenat);

        //查询服务详情的出入参数
        List<OcpApiParam> selects = ocpApiPMapper.selects(ocpApiRequirement.getApiCode());
        BeanUtils.copyProperties(ocpApiRequirement, apiRequirentVo);
        for (OcpApiParam select : selects) {
            if (select.getApiParamClassification().equals("out")) {
                list.add(select);
            } else if (select.getApiParamClassification().equals("in")) {
                lists.add(select);
            }
        }
        apiRequirentVo.setOutList(list);
        apiRequirentVo.setInList(lists);
        return apiRequirentVo;
    }



    @Override
    public ResponseVO<PageInfo<OcpApiRequirementVo>> OcpApiReqAcc(OcpApiRequirementVo ocpApiRequirementVo) {
        if (ocpApiRequirementVo.getCurrentPage() == null || ocpApiRequirementVo.getPageSize() == null) {
            return ResponseVO.error("分页参数不能为空");
        }
        apiGroupCode.add(ocpApiRequirementVo.getApiGroupCode());
        setGroupIdValue(ocpApiRequirementVo.getApiGroupCode(), ocpApiRequirementVo.getApiPromotion());
        PageHelper.startPage(ocpApiRequirementVo.getCurrentPage(), ocpApiRequirementVo.getPageSize());
        ocpApiRequirementVo.setApiGroupCodeList(apiGroupCode);
        List<OcpApiRequirementVo> ocpApiRequirements = ocpApiReqMapper.OcpApiReqAcc(ocpApiRequirementVo);
        apiGroupCode.clear();
        PageInfo<OcpApiRequirementVo> pageInfo = new PageInfo<>(ocpApiRequirements);
        return ResponseVO.ok(pageInfo);
    }



    @Override
    public ResponseVO<List<OcpApiRequirementVo>> selectOcpApiReqAcc(OcpApiRequirementVo ocpApiRequirementVo) {
        List<OcpApiRequirementVo> ocpApiRequirements = ocpApiReqMapper.selectOcpApiReq(ocpApiRequirementVo);
        return ResponseVO.ok(ocpApiRequirements);
    }

    @Override
    public ResponseVO<List<OcpApiRequirementVo>> OcpApiCheck(OcpApiRequirementVo ocpApiRequirementVo) {
        List<OcpApiRequirementVo> ocpApiRequirementVos = ocpApiReqMapper.OcpApiCheck(ocpApiRequirementVo);
        return ResponseVO.ok(ocpApiRequirementVos);
    }

    @Override
    public ResponseVO<List<OcpApiRequirementVo>> OarcCheck(OcpApiRequirementVo ocpApiRequirementVo) {
        List<OcpApiRequirementVo> ocpApiRequirementVos = ocpApiReqMapper.OarcCheck(ocpApiRequirementVo);
        return ResponseVO.ok(ocpApiRequirementVos);
    }


    @Override
    public ResponseVO<List<OcpApiRequirementVo>> OacrTreeApi(OcpApiRequirementVo ocpApiRequirementVo) {
        apiGroupCode.add(ocpApiRequirementVo.getApiGroupCode());
        setGroupIdValue(ocpApiRequirementVo.getApiGroupCode(), ocpApiRequirementVo.getApiPromotion());
        ocpApiRequirementVo.setApiGroupCodeList(apiGroupCode);
        List<OcpApiRequirementVo> ocpApiRequirementVos = ocpApiReqMapper.selectOcpAg(ocpApiRequirementVo);
        apiGroupCode.clear();
        return ResponseVO.ok(ocpApiRequirementVos);
    }

    @Override
    public ResponseVO<List<OcpApiRequirementVo>> getOcpTenantApiList(OcpApiRequirementVo ocpApiRequirementVo) {
        List<OcpApiRequirementVo> ocpApiRequirementVos = ocpApiReqMapper.getOcpTenantApiList(ocpApiRequirementVo);
        return ResponseVO.ok(ocpApiRequirementVos);
    }
}
