package com.pms.ocp.service.impl;


import cn.afterturn.easypoi.cache.manager.IFileLoader;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.graphbuilder.struc.LinkedList;
import com.pms.ocp.mapper.*;
import com.pms.ocp.model.dto.PageRequest;
import com.pms.ocp.model.dto.PhotoDto;
import com.pms.ocp.model.dto.PhotoListDto;
import com.pms.ocp.model.entity.*;
import com.pms.ocp.model.vo.ResponseVO;
import com.pms.ocp.service.OcpApiRequirementApprovalService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.sql.Timestamp;
import java.util.*;

@Service
public class OcpApiRequirementApprovalServiceImpl extends ServiceImpl<OcpApiRequirementApprovalMapper, OcpApiRequirementApproval> implements OcpApiRequirementApprovalService {


    @Autowired
    private OcpApiRequirementApprovalMapper ocpApiRequirementApprovalMapper;

    @Autowired
    private OcpApiRequirementMapper ocpApiRequirementMapper;

    @Autowired
    private OcpApiBaseMapper ocpApiBaseMapper;

    @Autowired
    private OcpBaseMapper ocpBaseMapper;

    @Autowired
    private OcpApiPMapper ocpApiPMapper;

    @Autowired
    private OcpApiModelRelMapper ocpApiModelRelMapper;

    @Autowired
    private ModelBaseMapper modelBaseMapper;

    @Autowired
    private ocpRequirementAcceptMapper ocpRequirementAcceptMapper;

    @Autowired
    private OcpApiAcceptMapper ocpApiAcceptMapper;


    /**
     * 服务需求审批--审核1
     *
     * @param ocpApiRequirementApproval
     * @return
     */
    @Override
    public ResponseVO inseterObj(OcpApiRequirementApproval ocpApiRequirementApproval) {

        Timestamp timestamp = new Timestamp(System.currentTimeMillis());
        //根据apiCode获取对象
        List<OcpApiRequirementApproval> requirementApproval = ocpApiRequirementApprovalMapper.selectByCodes(ocpApiRequirementApproval.getApiCode());
        if (org.springframework.util.StringUtils.isEmpty(requirementApproval)) {
            ocpApiRequirementApproval.setApprovalStats((long) 0);
            ocpApiRequirementApproval.setApprovalCtime(timestamp);
            ocpApiRequirementApproval.setApprovalMtime(timestamp);
            ocpApiRequirementApproval.setIsDelete((long) 0);
            ocpApiRequirementApprovalMapper.insert(ocpApiRequirementApproval);
        }

        List<OcpApiRequirementApproval> requirementApprovals = null;
        //根据apiCode和lastApprovalStats获取对象
        if ("null".equals(ocpApiRequirementApproval.getLastApprovalStats())) {
            requirementApprovals = ocpApiRequirementApprovalMapper.selectByLast(ocpApiRequirementApproval.getApiCode(), ocpApiRequirementApproval.getLastApprovalStats());
        }


        String objId = null;
        for (OcpApiRequirementApproval apiRequirementApproval : requirementApproval) {
            objId = apiRequirementApproval.getObjId();
        }

        ocpApiRequirementApproval.setApprovalMtime(timestamp);
        ocpApiRequirementApproval.setApprovalCtime(timestamp);
        String requirementCode = ocpApiRequirementApproval.getRequirementCode();
        //根据rrequirementCode获取ocp_api_requirement表中requirement_type字段类型
        OcpApiRequirement ocpApiRequirement = ocpApiRequirementMapper.selectbyCode(requirementCode);
        Long requirementType = ocpApiRequirement.getRequirementType();

        //根据apiCode查询服务对象


        OcpApiBase ocpApiBase = ocpBaseMapper.selectCode(ocpApiRequirementApproval.getApiCode());

//         判断是新增 迭代 还是 下线操作
        if (StringUtils.isBlank(ocpApiRequirementApproval.getLev())) {
            return ResponseVO.error("请先登录");
        } else {
            //         判断是否是新增
            if (requirementType == 0) {
                if (ocpApiRequirementApproval.getLev().equals("1")) {
                    ocpApiRequirementApproval.setApprovalAudit((long) 0);
                    ocpApiRequirementApprovalMapper.updateById(ocpApiRequirementApproval);
                } else if (ocpApiRequirementApproval.getLev().equals("2")) {
                    if (requirementApproval.size() < 3) {
                        ocpApiRequirementApproval.setApprovalCompanyCode("000000000000001");
                        ocpApiRequirementApproval.setApprovalDepartment("000000000000003");
                        ocpApiRequirementApproval.setApprovalStats((long) 1);
                        ocpApiRequirementApproval.setApprovalAudit((long) 1);
                        ocpApiRequirementApproval.setIsDelete((long) 0);
                        ocpApiRequirementApprovalMapper.insert(ocpApiRequirementApproval);
                    } else {
                        for (OcpApiRequirementApproval apiRequirement : requirementApproval) {
                            ocpApiRequirementApproval.setApprovalStats((long) 1);
                            ocpApiRequirementApproval.setApprovalAudit((long) 1);
                            ocpApiRequirementApproval.setIsDelete((long) 0);
                            ocpApiRequirementApprovalMapper.updateById(ocpApiRequirementApproval);
                        }

                    }


                }

                //判断是否是迭代
            } else if (requirementType == 1) {
                if (ocpApiRequirementApproval.getLev().equals("1")) {
                    ocpApiRequirementApproval.setApprovalStats((long) 1);
                    ocpApiRequirementApproval.setApprovalAudit((long) 0);
                    ocpApiRequirementApprovalMapper.updateById(ocpApiRequirementApproval);

                } else if (ocpApiRequirementApproval.getLev().equals("2")) {
                    //判断是否验收成功，确定是否删除迭代
                    if (ocpApiRequirementApproval.getLastApprovalStats() == 1) {
                        if (requirementApproval.size() <= 0) {
                            ocpApiRequirementApproval.setApprovalStats((long) 0);
                            ocpApiRequirementApproval.setApprovalAudit((long) 1);
                            ocpApiRequirementApproval.setIsDelete((long) 1);
                            ocpApiRequirementApprovalMapper.insert(ocpApiRequirementApproval);
                        } else {
                            ocpApiRequirementApproval.setApprovalAudit((long) 1);
                            ocpApiRequirementApproval.setIsDelete((long) 1);
                            ocpApiRequirementApprovalMapper.updateById(ocpApiRequirementApproval);
                        }
                    }

                }
                //判断是否是下线
            } else if (requirementType == 2) {
                for (OcpApiRequirementApproval apiReq : requirementApproval) {
                    if (ocpApiRequirementApproval.getLev().equals("1")) {
                        apiReq.setApprovalAudit((long) 0);
                        ocpApiRequirementApprovalMapper.updateById(apiReq);
                    } else if (ocpApiRequirementApproval.getLev().equals("2")) {
                        apiReq.setLastApprovalStats(ocpApiRequirementApproval.getLastApprovalStats());
                        apiReq.setApprovalAudit((long) 2);
                        apiReq.setApprovalStats((long) 1);
                        //判断是否审核通过下线
                        ocpApiRequirementApprovalMapper.updateById(apiReq);
                        if (ocpApiRequirementApproval.getLastApprovalStats() == 1) {
                            OcpApiBase ocpApiBase1 = ocpBaseMapper.selectCode(ocpApiRequirementApproval.getApiCode());
                            ocpBaseMapper.deleteById(ocpApiBase1.getObjId());
                        }
                    }
                }
            }


        }
        return ResponseVO.ok();
    }

    //服务需求审批-- 拓展图PhotoDto
    @Override
    public ResponseVO selectPhotos(String apiCode) {
//        ocp_api_model_rel
        PhotoListDto photoListDto = new PhotoListDto();
        List<PhotoDto> photoDto1 = new ArrayList<>();


        //获取modeCode和ModelName
        List<OcpApiParam> listParam = ocpApiPMapper.selectByList(apiCode);
        for (OcpApiParam ocpApiParam : listParam) {
            //出参
            List<String> list = new ArrayList<>();
            //入参
            List<String> lists = new ArrayList<>();

            PhotoDto photoDto = new PhotoDto();
            photoDto.setTitle(ocpApiParam.getModelName());
            String modelCode = ocpApiParam.getModelCode();
            //根据modelcode查询出入参
            List<OcpApiParam> list1 = ocpApiPMapper.selectsByModelCode(ocpApiParam.getModelCode());
            for (OcpApiParam apiParam : list1) {
                if (apiParam.getApiParamClassification().equals("out")) {
                    list.add(apiParam.getApiParamName());
                } else if (apiParam.getApiParamClassification().equals("in")) {
                    lists.add(apiParam.getApiParamName());
                }
//                Model model =  modelBaseMapper.selectByModelCode(apiParam.getModelCode());
//                photoDto.setModelTable(model.getModelTable());
            }
            photoDto.setOutPutList(list);
            photoDto.setInPutList(lists);
            photoDto1.add(photoDto);


        }
        photoListDto.setList(photoDto1);

        return ResponseVO.ok(photoListDto);
    }

    @Override
    public ResponseVO inseterGroupObj(OcpApiRequirementAccept ocpApiRequirementAccept) {

        String apiCode = ocpApiRequirementAccept.getApiCode();
        //根据apiCode查询验收表
     OcpApiRequirementAccept ocpApiRequirementAccept1 = ocpApiAcceptMapper.selectByCodeList(apiCode);
        if (!(org.springframework.util.StringUtils.isEmpty(ocpApiRequirementAccept1))){
            return ResponseVO.error("服务已提交！");
        }else {


            Timestamp timestamp = new Timestamp(System.currentTimeMillis());
//        OcpApiRequirementAccept ocpApiRequirementAccept = new OcpApiRequirementAccept();
            ocpApiRequirementAccept.setAcceptStats((long) 0);
            ocpApiRequirementAccept.setAcceptCtime(timestamp);
            ocpApiRequirementAccept.setAcceptCompanyCode("0");
            ocpApiRequirementAccept.setAcceptCompanyCode("0");
            ocpApiRequirementAccept.setAcceptMtime(timestamp);
            ocpApiRequirementAccept.setAcceptUserId("0");
            ocpApiRequirementAccept.setAcceptUserName("0");
            ocpApiRequirementAccept.setAcceptDepartment("0");
            ocpApiRequirementAccept.setIsDelete((long) 0);
            ocpRequirementAcceptMapper.insert(ocpApiRequirementAccept);
            return ResponseVO.ok();
        }
    }
}
